//
//  MLIMConstants.h
//  MaxLeapIM
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

// MaxLeap IM SDK Version
#define MaxLeap_IM_VERSION @"1.4.1"

FOUNDATION_EXPORT NSString * const MLIMErrorDomain;

typedef NS_ENUM(NSInteger, MLIMErrorCode) {
    kMLIMErrorUnknown = 1,
    KMLIMErrorServerException = 5000,
    kMLIMErrorInvalidParameter = 5001,
    kMLIMErrorServerDBError = 5002,
    kMLIMErrorNoPermission = 5003,
    kMLIMErrorNotFound = 5004,
    kMLIMErrorParameterConflict = 5005,
    kMLIMErrorS3UploadFailed = 5006,
    kMLIMErrorImageProcessingError = 5007,
    kMLIMErrorMemberCountHitTheLimit = 5008,
    kMLIMErrorUnsupportedOperation = 5009,
    kMLIMErrorParamTooLong = 5010,
    kMLIMErrorFileTooLarge = 5011,
    kMLIMErrorFileUploadFailed = 5012,
    kMLIMErrorSessionException = 5013,
    kMLIMErrorIncompleteAuthData = 5014,
    kMLIMErrorServerCacheException = 5015,
    kMLIMErrorMaxLeapServiceException = 5016,
    kMLIMErrorProcessAudioFailed = 5017,
    kMLIMErrorInvalidQuery = 5018,
    
    kMLIMErrorHitTheLimit = kMLIMErrorMemberCountHitTheLimit
};

typedef void (^MLIMBooleanResultBlock)(BOOL succeeded, NSError *__nullable error);
typedef void (^MLIMIntegerResultBlock)(NSInteger number, NSError *__nullable error);
typedef void (^MLIMIdResultBlock)(id __nullable object, NSError *__nullable error);
typedef void (^MLIMProgressBlock)(int percentDone);
typedef void (^MLIMStringResultBlock)(NSString *__nullable string, NSError *__nullable error);


NS_ASSUME_NONNULL_END

